
public class Speed5 {

  public static void main(String[] args) {
    System.out.println("Entering main().");
    int arg1, arg2;                                         // (1)
    try {                                                   // (2)
      arg1 = Integer.parseInt(args[0]);                     // (3)
      arg2 = Integer.parseInt(args[1]);                     // (4)
    }
    catch (ArrayIndexOutOfBoundsException exception) {      // (5)
      System.out.println("Specify both kilometers and hours.");
      System.out.println("Usage: java Speed5 <kilometers> <hours>");
      System.out.println(exception  + " (handled in main())");
      return;
    }
    catch (NumberFormatException exception) {               // (6)
      System.out.println("Kilometers and hours must be integers.");
      System.out.println("Usage: java Speed5 <kilometers> <hours>");
      System.out.println(exception  + " (handled in main())");
      return;
    }
    printSpeed(arg1, arg2);                                 // (7)
    System.out.println("Returning from main().");
  }

  private static void printSpeed(int kilometers, int hours) {
    System.out.println("Entering printSpeed().");
    try {
      int speed = calculateSpeed(kilometers, hours);
      System.out.println("Speed = " +
                          kilometers + "/" + hours + " = " + speed);
    }
    catch (ArithmeticException exception) {
      System.out.println(exception  + " (handled in printSpeed())");
    }
    System.out.println("Returning from printSpeed().");
  }

  private static int calculateSpeed(int distance, int time) {
    System.out.println("Calculating speed.");
    if (distance < 0 || time < 0)
      throw new ArithmeticException("distance and time cannot be < 0");
    return distance/time;
  }
}